<?php
/**
*
* @package ucp
* @version $Id: ucp_zebra.php 8479 2008-03-29 00:22:48Z naderman $
* @copyright (c) 2005 phpBB Group
* @copyright (c) mtrs 2009 - modified copy of ucp_zebra.php as ucp_zebra_pm.php for PM Blocking by Users mod 1.0.0 - 21.11.2009
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_zebra
* @package ucp
*/
class ucp_zebra_pm
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $phpbb_root_path, $phpEx;
		
		//add is friend foe username list, add2 is the block reason list
		$submit	= (isset($_POST['submit']) || isset($_GET['add']) || isset($_GET['add2']) || isset($_GET['remove'])) ? true : false;
		$s_hidden_fields = '';
		$user->add_lang('mods/pm_block');

		$l_mode = strtoupper($mode);

		if ($submit)
		{
			$data = $error = array();
			$updated = false;

			$var_ary = array(
				'usernames'	=> array(0),
				'add'		=> '',
				'add2'		=> '',
			);

			foreach ($var_ary as $var => $default)
			{
				$data[$var] = utf8_normalize_nfc(request_var($var, $default, true));
			}

			if (!empty($data['add']) || sizeof($data['usernames']))
			{
				if (confirm_box(true))
				{
					if ($data['add'])
					{
						$data['add'] = array_map('trim', array_map('utf8_clean_string', explode("\n", $data['add'])));
						$data['add2'] = array_map('trim', explode("\n", $data['add2']));
						// Do these name/s exist on a list already? If so, ignore ... we could be
						// 'nice' and automatically handle names added to one list present on
						// the other (by removing the existing one) ... but I have a feeling this
						// may lead to complaints
						$sql = 'SELECT z.*, u.username, u.username_clean
							FROM ' . ZEBRA_PM_TABLE . ' z, ' . USERS_TABLE . ' u
							WHERE z.user_id = ' . $user->data['user_id'] . '
								AND u.user_id = z.zebra_pm_id';
						$result = $db->sql_query($sql);

						$friends = $foes = array();
						while ($row = $db->sql_fetchrow($result))
						{
							if ($row['friend'])
							{
								$friends[] = utf8_clean_string($row['username']);
							}
							else if ($row['foe'])
							{
								$foes[] = utf8_clean_string($row['username']);
							}
						}
						$db->sql_freeresult($result);

						//prevent adding pm foes if pm friends list is not empty
						$n = sizeof($data['add']);
						$data['add'] = array_diff($data['add'], $friends);

						if ($n && $mode == 'foes' && sizeof($friends))
						{
							$data['add'] = array();
							$error[] = $user->lang['NOT_ADDED_PM_FOES_FRIENDS'];
						}
						
						//prevent adding pm friends if pm foes list is not empty
						$n = sizeof($data['add']);
						$data['add'] = array_diff($data['add'], $foes);

						if ($n && $mode == 'friends' && sizeof($foes))
						{
							$data['add'] = array();
							$error[] = $user->lang['NOT_ADDED_PM_FRIENDS_FOES'];						
						}

						// remove the user himself from the username array
						$n = sizeof($data['add']);
						$data['add'] = array_diff($data['add'], array(utf8_clean_string($user->data['username'])));
						
						if (sizeof($data['add']) < $n)
						{
							$error[] = $user->lang['NOT_ADDED_PM_' . $l_mode . '_SELF'];
						}
						unset($friends, $foes, $n);

						$reason_name = $reason = array();
						$reason_exists = (sizeof($data['add']) == sizeof($data['add2'])) ? true : false;
						if ($reason_exists)
						{
							for ($i = 0, $j = sizeof($data['add']); $i < $j; $i++)
							{
								$reason_name[$data['add'][$i]] = (utf8_strlen($data['add2'][$i]) < 60) ? $data['add2'][$i] : (utf8_substr($data['add2'][$i], 0, 58) . '..');
							}
						}
									
						if (sizeof($data['add']))
						{
							$sql = 'SELECT user_id, user_type, username_clean
								FROM ' . USERS_TABLE . '
								WHERE ' . $db->sql_in_set('username_clean', $data['add']) . '
									AND user_type <> ' . USER_INACTIVE;
							$result = $db->sql_query($sql);

							$user_id_ary = array();
							while ($row = $db->sql_fetchrow($result))
							{
								if ($row['user_id'] != ANONYMOUS && $row['user_type'] != USER_IGNORE)
								{
									$user_id_ary[] = $row['user_id'];
									if ($reason_exists)
									{
										$reason[$row['user_id']] = $reason_name[$row['username_clean']];
									}
								}
								else
								{
									$error[] = $user->lang['NOT_ADDED_PM_' . $l_mode . '_ANONYMOUS'];
								}
							}
							$db->sql_freeresult($result);

							if (sizeof($user_id_ary))
							{
								// Remove users from foe list if they are admins or moderators
								if ($mode == 'foes')
								{
									$perms = array();
									foreach ($auth->acl_get_list($user_id_ary, array('a_', 'm_')) as $forum_id => $forum_ary)
									{
										foreach ($forum_ary as $auth_option => $user_ary)
										{
											$perms = array_merge($perms, $user_ary);
										}
									}

									$perms = array_unique($perms);

									if (sizeof($perms))
									{
										$error[] = $user->lang['NOT_ADDED_PM_FOES_MOD_ADMIN'];
									}

									// This may not be right ... it may yield true when perms equate to deny
									$user_id_ary = array_diff($user_id_ary, $perms);
									unset($perms);
								}

								if (sizeof($user_id_ary))
								{
									$sql_mode = ($mode == 'friends') ? 'friend' : 'foe';

									$sql_ary = array();

									foreach ($user_id_ary as $zebra_pm_id)
									{
										$sql_ary[] = array(
											'user_id'			=> (int) $user->data['user_id'],
											'zebra_pm_id'		=> (int) $zebra_pm_id,
											'zebra_pm_reason'	=> (string) ((sizeof($user_id_ary) != sizeof($data['add2']) || $mode == 'friends') ? '' : $reason[$zebra_pm_id]),
											$sql_mode		=> 1
										);
									}

									$db->sql_multi_insert(ZEBRA_PM_TABLE, $sql_ary);

									$updated = true;
								}
								unset($user_id_ary);
							}
							else if (!sizeof($error))
							{
								$error[] = $user->lang['USER_NOT_FOUND_OR_INACTIVE'];
							}
						}
					}
					else if (sizeof($data['usernames']))
					{
						// Force integer values
						$data['usernames'] = array_map('intval', $data['usernames']);

						$sql = 'DELETE FROM ' . ZEBRA_PM_TABLE . '
							WHERE user_id = ' . $user->data['user_id'] . '
								AND ' . $db->sql_in_set('zebra_pm_id', $data['usernames']);
						$db->sql_query($sql);

						$updated = true;
					}

					if ($updated)
					{
						meta_refresh(3, $this->u_action);
						$message = $user->lang['PM_' . $l_mode . '_UPDATED'] . '<br />' . implode('<br />', $error) . ((sizeof($error)) ? '<br />' : '') . '<br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);
					}
					else
					{
						$template->assign_var('ERROR', implode('<br />', $error));
					}
				}
				else
				{
					confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
						'mode'		=> $mode,
						'submit'	=> true,
						'usernames'	=> $data['usernames'],
						'add'		=> $data['add'],
						'add2'		=> $data['add2']))
					);
				}
			}
		}
		
		$sql_and = ($mode == 'friends') ? 'z.friend = 1' : 'z.foe = 1';
		$sql = 'SELECT z.*, u.username, u.username_clean
			FROM ' . ZEBRA_PM_TABLE . ' z, ' . USERS_TABLE . ' u
			WHERE z.user_id = ' . $user->data['user_id'] . "
				AND $sql_and
				AND u.user_id = z.zebra_pm_id
			ORDER BY u.username_clean ASC";
		$result = $db->sql_query($sql);

		$s_username_options = '';
		$s_username_reason_options = '';
		while ($row = $db->sql_fetchrow($result))
		{
			if (!empty($row['zebra_pm_reason']) && $mode == 'foes' && $config['pm_foe_reason_enable'])
			{
				$s_username_options .= '<option value="' . $row['zebra_pm_id'] . '">' . $row['username'] . ': ' . $row['zebra_pm_reason'] . '</option>';
			}
			else 
			{
				$s_username_options .= '<option value="' . $row['zebra_pm_id'] . '">' . $row['username'] . ' </option>';
			}			
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'L_TITLE'				=> $user->lang['UCP_ZEBRA_PM_' . $l_mode],
			'U_FIND_USERNAME'		=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=ucp&amp;field=add'),
			'S_USERNAME_OPTIONS'	=> $s_username_options,
			'S_HIDDEN_FIELDS'		=> $s_hidden_fields,
			'S_FOE_REASON_ENABLE'	=> $config['pm_foe_reason_enable'],
			'S_UCP_ACTION'			=> $this->u_action)
		);

		$this->tpl_name = 'ucp_zebra_pm_' . $mode;
		$this->page_title = 'UCP_ZEBRA_PM_' . $l_mode;
	}
}

?>