<?php
/**
*
* @author mtrs (mtrs) trst2007@gmail.com 
* @package umil
* @version $Id install_pm_blocking.php 1.0.0 2009-12-12 17:29:18GMT mtrs $
* @copyright (c) 2009 mtrs 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'PM_BLOCKING';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'pm_blocking_version';

$language_file = 'mods/umil_pm_block';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(

	// Version 0.0.1
	'0.0.1'	=> array(
		//Remove old config
		'config_add' => array(
			array('enable_foe_pm_blocking', false),
		),
		
		// Lets add a new column 
		'table_column_add' => array(
			array('phpbb_users', 'user_no_pms_to', array('VCHAR:255', NULL)),
		),
	),
	// Version 0.0.2
	'0.0.2'	=> array(
		// Lets add a config setting named test_enable and set it to true
		'config_add' => array(
			array('pm_blocking_enable', false),
		),
		//Remove old config
		'config_remove' => array(
			array('enable_foe_pm_blocking', false),
		),
	),
	
	// Version 0.0.3
	'0.0.3'	=> array(
		// Lets add a new column 
		'table_column_update' => array(
			array('phpbb_users', 'user_no_pms_to', array('VCHAR:255', '')),
		),
	),	

	// Version 0.0.4
	'0.0.4'	=> array(
		// Nothing changed in this version.
	),	
	
	// Version 0.0.5
	'0.0.5'	=> array(

		// Now to add a table (this uses the layout from develop/create_schema_files.php and from phpbb_db_tools)
		
		'table_add' => array(
			array('phpbb_zebra_pm', array(
					'COLUMNS'		=> array(
						'user_id'				=> array('UINT', 0),
						'zebra_pm_id'			=> array('UINT', 0),
						'foe'					=> array('BOOL', 0),						
					),
					'PRIMARY_KEY'  => array('user_id', 'zebra_pm_id'),
				),
			),
		),
		
		// Alright, now lets add some modules to the UCP
		'module_add' => array(
			// Now we will add the modules manually
            array('ucp', 'UCP_PM', array(
						'module_basename'   => 'zebra_pm',
						'module_langname'   => 'UCP_ZEBRA_PM_FOES',
						'module_mode'       => 'foes',
						'module_auth'       => 'acl_u_pmblock',
					),
			),
		),
		
		// Now to add some permission settings
		'permission_add' => array('u_pmblock', true),
	),	
	
	// Version 0.0.6
	'0.0.6'	=> array(
		// Lets add a new column
		'table_column_add' => array(
			array('phpbb_zebra_pm', 'zebra_pm_reason', array('VCHAR:80', '')),
		),

	),	

	// Version 0.0.7
	'0.0.7'	=> array(
		// Nothing changed in this version.
	),	
		
	// Version 0.0.8
	'0.0.8'	=> array(

	'module_add' => array(
			// Now we will add the modules manually
            array('ucp', 'UCP_PM', array(
						'module_basename'   => 'zebra_pm',
						'module_langname'   => 'UCP_ZEBRA_PM_FRIENDS',
						'module_mode'       => 'friends',
						'module_auth'       => 'acl_u_pmblock',
					),
			),			
		),
		
		// Lets add a new column
		'table_column_add' => array(
			array('phpbb_zebra_pm', 'friend', array('BOOL', 0)),
		),
	),
		
	// Version 0.0.9
	'0.0.9'	=> array(
		// Nothing changed in this version.
	),
	
	// Version 1.0.0-RC1
	'1.0.0-RC1'	=> array(
		// Nothing changed in this version.
	),
	
	// Version 1.0.0-RC2
	'1.0.0-RC2'	=> array(
		// Nothing changed in this version.
	),
	
	// Version 1.0.0-RC3
	'1.0.0-RC3'	=> array(
		// Lets add a config setting named test_enable and set it to true
		'config_add' => array(
			array('pm_zebra_enable', false),
		),		
	),
	// Version 1.0.0-RC4
	'1.0.0-RC4'	=> array(
		// Lets add a config setting named test_enable and set it to true
		'config_add' => array(
			array('pm_foe_friend_enable', false),
			array('pm_foe_reason_enable', false),
			array('pm_admin_block_enable', false),			
		),
		//We remove and add modules to update them
		'module_remove' => array(
			// Now we will remove the modules manually
            array('ucp', 'UCP_PM', array(
						'module_basename'   => 'zebra_pm',
						'module_langname'   => 'UCP_ZEBRA_PM_FOES',
						'module_mode'       => 'foes',
						'module_auth'       => 'acl_u_pmblock',
					),
			),			
            array('ucp', 'UCP_PM', array(
						'module_basename'   => 'zebra_pm',
						'module_langname'   => 'UCP_ZEBRA_PM_FRIENDS',
						'module_mode'       => 'friends',
						'module_auth'       => 'acl_u_pmblock',
					),
			),
		),

		'module_add' => array(
			// Now we will add the modules manually
            array('ucp', 'UCP_PM', array(
						'module_basename'   => 'zebra_pm',
						'module_langname'   => 'UCP_ZEBRA_PM_FOES',
						'module_mode'       => 'foes',
						'module_auth'       => 'acl_u_pmblock && cfg_pm_foe_friend_enable',
					),
			),				
            array('ucp', 'UCP_PM', array(
						'module_basename'   => 'zebra_pm',
						'module_langname'   => 'UCP_ZEBRA_PM_FRIENDS',
						'module_mode'       => 'friends',
						'module_auth'       => 'acl_u_pmblock && cfg_pm_foe_friend_enable',
					),
			),	
		),

	),
	
	// Version 1.0.0-RC5
	'1.0.0-RC5'	=> array(
		// Nothing changed in this version.
	),
	
	// Version 1.0.0-RC6
	'1.0.0-RC6'	=> array(
		// Nothing changed in this version.
	),	
	
	// Version 1.0.0-RC7
	'1.0.0-RC7'	=> array(
		// Nothing changed in this version.
	),		
	
	// Version 1.0.0
	'1.0.0'	=> array(
		// Nothing changed in this version.
	),	
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);


?>